From 7e0eea7d7b34b81ca02ffb995ebea22c02cb92d2 Mon Sep 17 00:00:00 2001
From: Daniel Stenberg <daniel@haxx.se>
Date: Thu, 3 Apr 2025 19:34:33 +0200
Subject: [PATCH] tests: mark ipfs tests to require ipfs

Fixes #16947
Reported-by: Daniel Engberg
Closes #16948
---
 tests/data/test722 | 3 +++
 tests/data/test723 | 3 +++
 tests/data/test724 | 3 +++
 tests/data/test725 | 3 +++
 tests/data/test726 | 3 +++
 tests/data/test727 | 3 +++
 tests/data/test730 | 3 +++
 tests/data/test731 | 3 +++
 tests/data/test732 | 3 +++
 tests/data/test733 | 3 +++
 tests/data/test734 | 3 +++
 tests/data/test735 | 3 +++
 tests/data/test736 | 3 +++
 tests/data/test737 | 3 +++
 tests/data/test738 | 3 +++
 tests/data/test739 | 3 +++
 tests/data/test740 | 3 +++
 tests/data/test741 | 3 +++
 18 files changed, 54 insertions(+)

diff --git a/tests/data/test722 b/tests/data/test722
index c5b8d86100c5..bff6c33e9392 100644
--- a/tests/data/test722
+++ b/tests/data/test722
@@ -27,6 +27,9 @@ Hello curl from IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test723 b/tests/data/test723
index dac78fc5448d..9ad7de928fcb 100644
--- a/tests/data/test723
+++ b/tests/data/test723
@@ -13,6 +13,9 @@ IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test724 b/tests/data/test724
index c97354b0d9a3..85cf07d141e7 100644
--- a/tests/data/test724
+++ b/tests/data/test724
@@ -27,6 +27,9 @@ Hello curl from IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test725 b/tests/data/test725
index de7c3949304b..2bf6d1e4c7c1 100644
--- a/tests/data/test725
+++ b/tests/data/test725
@@ -13,6 +13,9 @@ IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test726 b/tests/data/test726
index f51adf594e63..54a07de70cf3 100644
--- a/tests/data/test726
+++ b/tests/data/test726
@@ -13,6 +13,9 @@ IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test727 b/tests/data/test727
index aa2c84fbcff3..3f9a91e7d905 100644
--- a/tests/data/test727
+++ b/tests/data/test727
@@ -27,6 +27,9 @@ Hello curl from IPNS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test730 b/tests/data/test730
index 138f850863a1..ba18888c33db 100644
--- a/tests/data/test730
+++ b/tests/data/test730
@@ -27,6 +27,9 @@ Hello curl from IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test731 b/tests/data/test731
index 9e135dbec593..a2e0ee8a635a 100644
--- a/tests/data/test731
+++ b/tests/data/test731
@@ -27,6 +27,9 @@ Hello curl from IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test732 b/tests/data/test732
index 9adaedb93bd4..3a4e0e81920d 100644
--- a/tests/data/test732
+++ b/tests/data/test732
@@ -27,6 +27,9 @@ Hello curl from IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test733 b/tests/data/test733
index ad17cd4bf489..e6a4693b1102 100644
--- a/tests/data/test733
+++ b/tests/data/test733
@@ -27,6 +27,9 @@ Hello curl from IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test734 b/tests/data/test734
index 03f571cc6b22..1545551ad093 100644
--- a/tests/data/test734
+++ b/tests/data/test734
@@ -27,6 +27,9 @@ Hello curl from IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test735 b/tests/data/test735
index da1aac4ddd86..8d9fa156f0e2 100644
--- a/tests/data/test735
+++ b/tests/data/test735
@@ -27,6 +27,9 @@ Hello curl from IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test736 b/tests/data/test736
index 45d9a055a84e..b239b259fc71 100644
--- a/tests/data/test736
+++ b/tests/data/test736
@@ -27,6 +27,9 @@ Hello curl from IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test737 b/tests/data/test737
index bc6e8576a43d..0dc4b6882535 100644
--- a/tests/data/test737
+++ b/tests/data/test737
@@ -27,6 +27,9 @@ Hello curl from IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test738 b/tests/data/test738
index 5c05137dc3c9..f79d16734d2c 100644
--- a/tests/data/test738
+++ b/tests/data/test738
@@ -13,6 +13,9 @@ IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test739 b/tests/data/test739
index fe78c41bba7f..41fa8e1dbe47 100644
--- a/tests/data/test739
+++ b/tests/data/test739
@@ -13,6 +13,9 @@ IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test740 b/tests/data/test740
index 97258d3842b8..599adece2bff 100644
--- a/tests/data/test740
+++ b/tests/data/test740
@@ -27,6 +27,9 @@ Hello curl from IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>
diff --git a/tests/data/test741 b/tests/data/test741
index e773cd08a2e6..b0517c14a727 100644
--- a/tests/data/test741
+++ b/tests/data/test741
@@ -13,6 +13,9 @@ IPFS
 #
 # Client-side
 <client>
+<features>
+ipfs
+</features>
 <server>
 http
 </server>